"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

'From Smalltalk/X, Version:2.10.8 on 6-feb-1996 at 15:31:35'                    !

WriteStream subclass:#ReadWriteStream
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Streams'
!

!ReadWriteStream class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    ReadWriteStreams allow both read- and write-access to some collection.
    To allow this, they reenable some methods blocked in WriteStream.
    (being one of the seldom places, where multiple inheritance could be
     of good use in smalltalk).

    Claus:
	I personally find the ReadStream - WriteStream - ReadWriteStream
	organization brain-damaged. It would be better to have an attribute
	(such as readOnly / writeOnly / readWrite) in an InternalStream subclass 
	of Stream ...
"
! !

!ReadWriteStream methodsFor:'access-reading'!

next
    "return the next element; advance read position.
     If there are no more elements, nil is returned."

    |element|

    (position > readLimit) ifTrue:[^ self pastEnd].
    element := collection at:position.
    position := position + 1.
    ^ element

    "Modified: 5.2.1996 / 21:57:40 / stefan"
!

peek
    "return the element to be read next without advancing read position.
     If there are no more elements, nil is returned."

    (position > readLimit) ifTrue:[^ self pastEnd].
    ^ collection at:position

    "Modified: 5.2.1996 / 21:57:47 / stefan"
! !

!ReadWriteStream methodsFor:'converting'!

readStream
    ^ self

    "Created: 29.11.1995 / 22:04:23 / stefan"
! !

!ReadWriteStream methodsFor:'positioning'!

reset
    "re-redefine to not clobber the collection"

    position := "0" 1
! !

!ReadWriteStream methodsFor:'queries'!

isReadable 
    ^ true
! !

!ReadWriteStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic/ReadWriteStream.st,v 1.16 1996-02-19 15:07:27 stefan Exp $'
! !
